<template>
  <div class="bg-white shadow-md border border-indigo-500 rounded-lg p-8">
    <div
      v-if="this.user ? user.roles.includes('ROLE_SUPER_ADMIN') : false"
      class="flex justify-end"
      @click="deleteComment"
    >
      <font-awesome-icon icon="trash" />
    </div>
    <h5 class="text-gray-900 font-bold text-2xl tracking-tight mb-2">
      De : <span class="text-indigo-500">{{ author }}</span>
    </h5>
    <p class="font-normal text-gray-700 mb-3">
      {{ message }}
    </p>
    <p class="flex justify-end text-gray-500">
      {{ date | formatDate }}
    </p>

    <p></p>
  </div>
</template>

<script>
export default {
  name: "CommentCard",
  props: {
    author: String,
    message: String,
    date: {
      type: String,
      default: ""
    },
    id: String,
    deleteComment: Function
  },
  inject: ["user", "createAlert"],
  data() {
    return {
      urlGameComment: `https://${window.location.hostname}:8443/comment/`
    }
  },
  methods: {
    deleteComment: function() {
      const headers = {
        Accept: "application/json",
        "Content-Type": "application/json",
        Authorization: "Bearer " + this.user.token
      }

      fetch(this.urlGameComment + this.id, {
        headers,
        method: "DELETE",
      })
        .then((res) => {
          if (res.ok) {
            this.$emit('delete')
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped></style>
